angular.module('starter', ['ionic', 'starter.aboutService', 'starter.apiService', 'starter.utilService', 'starter.config', 'starter.filter', 'starter.interceptor'])

  .run(function ($ionicPlatform, $rootScope, $ionicLoading, $http,Constants) {
    var deviceWidth = document.documentElement.clientWidth;
    var proportion = 20 / 750;
    if (deviceWidth > 750) deviceWidth = 750;
    if ($ionicPlatform.is("android")) {
      deviceWidth = deviceWidth * 375 / 360;
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    } else {
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    }
    $rootScope.$on("loading:show", function () {
      $ionicLoading.show({
        templateUrl: '../../templates/loading.html'
      });
      //$ionicLoading.show({template: 'Loading...'});
    });
    $rootScope.$on("loading:hide", function () {
      $ionicLoading.hide();
    });

    $ionicPlatform.ready(function () {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);

      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        StatusBar.styleDefault();
      }
    });

    //网络请求全局配置
    $http.defaults.headers.get = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.post = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.put = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.detele = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
  })

  .config(function ($ionicConfigProvider,$httpProvider) {

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    $ionicConfigProvider.platform.ios.scrolling.jsScrolling(true);
    $ionicConfigProvider.platform.android.scrolling.jsScrolling(true);

    //添加http请求拦截器
    $httpProvider.interceptors.push('httpInterceptor');

  })
  .controller("aboutController", function ($rootScope, $scope, aboutService,utilService) {
    $rootScope.$broadcast("loading:show");
    aboutService.getSysInfo();
    $scope.version = "";
    $scope.$on("sysinfo:success", function () {
      $scope.sysInfo = aboutService.getSysInfoData();
      $scope.version = "版本号："+utilService.getQueryUrlString("version");
    });
  });
