angular.module('starter', ['ionic', 'starter.homeService', 'starter.apiService', 'starter.utilService', 'starter.config', 'starter.filter', 'starter.interceptor'])

  .run(function ($ionicPlatform, $rootScope, $ionicLoading, $http,Constants) {
    var deviceWidth = document.documentElement.clientWidth;
    var proportion = 20 / 750;
    if (deviceWidth > 750) deviceWidth = 750;
    if ($ionicPlatform.is("android")) {
      deviceWidth = deviceWidth * 375 / 360;
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    } else {
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    }
    $rootScope.$on("loading:show", function () {
      $ionicLoading.show({
        templateUrl: '../templates/loading.html'
      });
      //$ionicLoading.show({template: 'Loading...'});
    });
    $rootScope.$on("loading:hide", function () {
      $ionicLoading.hide();
    });

    $ionicPlatform.ready(function () {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);

      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        StatusBar.styleDefault();
      }
    });

    //网络请求全局配置
    $http.defaults.headers.get = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.post = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.put = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.detele = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
  })

  .config(function ($ionicConfigProvider,$httpProvider) {

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    $ionicConfigProvider.platform.ios.scrolling.jsScrolling(true);
    $ionicConfigProvider.platform.android.scrolling.jsScrolling(true);

    //添加http请求拦截器
    $httpProvider.interceptors.push('httpInterceptor');

  })
  .controller("HomeCtrl", function ($rootScope, $scope, $ionicHistory, homeService, apiService, utilService, Constants, $ionicSlideBoxDelegate, $ionicPlatform) {
    //清除缓存 历史访问
    $scope.showloading = true;
    $scope.showMoreloading = false;
    $scope.mutiListData = [];
    homeService.getTopAdListData();
    homeService.getTopHomePageQuestionList();
    //数据改变广播
    $scope.$on('homepagequestionlist:success', function () {
      $scope.showloading = false;
      $scope.showMoreloading = false;
      $scope.qustionListData = homeService.getQustionListData();
      $scope.mutiListData = homeService.getMutiListData();
      //取消刷新数据
      $scope.$broadcast('scroll.refreshComplete');
      //取消加载更多数据
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });

    $scope.$on('homepageadlist:success', function () {
      $scope.adDataList = homeService.getAdListData();
      $ionicSlideBoxDelegate.$getByHandle("slideimgs").update();
      $ionicSlideBoxDelegate.$getByHandle("slideimgs").loop(true);
      $ionicSlideBoxDelegate.$getByHandle("slideimgs").slide(0);
      $ionicSlideBoxDelegate.$getByHandle("slideimgs2").update();
      $ionicSlideBoxDelegate.$getByHandle("slideimgs2").loop(true);
      $ionicSlideBoxDelegate.$getByHandle("slideimgs2").slide(0);
    });

    //刷新列表数据
    $rootScope.$on("homepagequestionlist:refresh", function () {
      homeService.getTopHomePageQuestionList();
    });

    //下拉更新
    $scope.doRefresh = function () {
      $scope.showloading = false;
      homeService.getTopAdListData();
      homeService.getTopHomePageQuestionList();
    }

    //上拉加载更多
    $scope.loadMore = function () {
      $scope.showMoreloading = true;
      homeService.getMoreHomePageQuestionList();
    }
    //判断是否有下页数据
    $scope.hasNextPage = function () {
      return homeService.hasNextPage();
    };

    //判断是否有数据
    $scope.hasData = function () {
      return $scope.showloading || homeService.hasData();
    };

    /**
     * 判断是否存在广告数据
     * @returns {*}
     */
    $scope.hasAdData = function () {
      if ($scope.adDataList == undefined || $scope.adDataList == null) {
        return false;
      } else {
        return true;
      }
    };


    /**
     * 判断用户是否登录
     */
    $scope.isLogin = function () {
      return utilService.isLogin();
    }

    /**
     * 获取用户id
     */
    $scope.getUserId = function () {
      return utilService.getUserId();
    }

    /**
     * 页面滚动完成
     */
    $scope.onScrollComplete = function () {
      $ionicSlideBoxDelegate.$getByHandle("slideimgs").start();
      $ionicSlideBoxDelegate.$getByHandle("slideimgs2").start();
    }

    /**
     * 点击广告
     * @param item
     */
    $scope.linkUri = function (item) {
      switch (item.linkType) {
        case "00":
          //无链接
          break;
        case "01":
          //内链
          homeService.doReadAdvert(item.adId);
          if ($ionicPlatform.is("android")) {
            window.jsObj.homeClickAdvert(item.adId, item.linkUrl, item.adInfo);
          }
          if ($ionicPlatform.is("ios")) {
            homeClickAdvert(item.adId, item.linkUrl, item.adInfo);
          }
          break;
        case "02":
          //外链
          homeService.doReadAdvert(item.adId);
          if ($ionicPlatform.is("android")) {
            window.jsObj.homeClickAdvert(item.adId, item.linkUrl, item.adInfo);
          }
          if ($ionicPlatform.is("ios")) {
            homeClickAdvert(item.adId, item.linkUrl, item.adInfo);
          }
          break;
        default:
          break;
      }
    }
    /**
     * 点击视频item
     * @param item
     */
    $scope.clickMutiItem = function (item) {
      if ($ionicPlatform.is("android")) {
        window.jsObj.homeClickMutiItem(angular.toJson(item));
      }
      if ($ionicPlatform.is("ios")) {
        homeClickMutiItem(item);
      }
    }

    /**
     * 点击item
     * @param item
     */
    $scope.clickItem = function (item) {
      if ($ionicPlatform.is("android")) {
        window.jsObj.homeClickItem(angular.toJson(item));
      }
      if ($ionicPlatform.is("ios")) {
        homeClickItem(item);
      }
    }

    /**
     * 点击item头像
     * @param item
     */
    $scope.clickItemHead = function (item, $event) {
      $event.stopPropagation();
      if ($ionicPlatform.is("android")) {
        window.jsObj.homeClickItemHead(angular.toJson(item));
      }
      if ($ionicPlatform.is("ios")) {
        homeClickItemHead(item);
      }
    }

    /**
     * 跳转至我问页面
     * @param type 0老师 1最新问题 2最热问题 3眼界 4课堂 5榜样
     */
    $scope.goto = function (type) {
      if ($ionicPlatform.is("android")) {
        window.jsObj.homeClickIndex(type);
      }
      if ($ionicPlatform.is("ios")) {
        homeClickIndex(type);
      }
    }

    /**
     * 获取视频封面的url
     * @param item
     * @returns {*}
     */
    $scope.getMutiImgUrl = function (item) {
      if(item.mutiHomeImgUrl===undefined||item.mutiHomeImgUrl==null||item.mutiHomeImgUrl==''){
        return item.mutiImgUrl;
      }else{
        return item.mutiHomeImgUrl;
      }
    }

  });
