angular.module('starter', ['ionic', 'starter.myCollectionService', 'starter.apiService', 'starter.utilService', 'starter.config', 'starter.filter', 'starter.interceptor'])

  .run(function ($ionicPlatform, $rootScope, $ionicLoading,$http,Constants) {
    var deviceWidth = document.documentElement.clientWidth;
    var proportion = 20 / 750;
    if (deviceWidth > 750) deviceWidth = 750;
    if ($ionicPlatform.is("android")) {
      deviceWidth = deviceWidth * 375 / 360;
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    } else {
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    }
    $rootScope.$on("loading:show", function () {
      $ionicLoading.show({
        templateUrl: '../../templates/loading.html'
      });
      //$ionicLoading.show({template: 'Loading...'});
    });
    $rootScope.$on("loading:hide", function () {
      $ionicLoading.hide();
    });

    $ionicPlatform.ready(function () {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);

      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        StatusBar.styleDefault();
      }
    });

    //网络请求全局配置
    $http.defaults.headers.get = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.post = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.put = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.detele = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
  })

  .config(function ($ionicConfigProvider,$httpProvider) {

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    $ionicConfigProvider.platform.ios.scrolling.jsScrolling(true);
    $ionicConfigProvider.platform.android.scrolling.jsScrolling(true);

    //添加http请求拦截器
    $httpProvider.interceptors.push('httpInterceptor');

  })
  .controller('myCollectionController', function ($scope, $ionicHistory, myCollectionService, $ionicPlatform) {
    $scope.showloading = true;
    $scope.showMoreloading = false;
    myCollectionService.getTopCollectionList();
    //数据改变广播
    $scope.$on('collectionListData.Updated', function () {
      $scope.showloading = false;
      $scope.showMoreloading = false;
      $scope.collectionListData = myCollectionService.getCollectionListData();
      //取消刷新数据
      $scope.$broadcast('scroll.refreshComplete');
      //取消加载更多数据
      $scope.$broadcast('scroll.infiniteScrollComplete');
    });

    //下拉更新
    $scope.doRefresh = function () {
      $scope.showloading = false;
      myCollectionService.getTopCollectionList();
    }

    //上拉加载更多
    $scope.loadMore = function () {
      $scope.showMoreloading = true;
      myCollectionService.getMoreCollectionList();
    }
    //判断是否有下页数据
    $scope.hasNextPage = function () {
      return myCollectionService.hasNextPage();
    };

    //判断是否有数据
    $scope.hasData = function () {
      return $scope.showloading || myCollectionService.hasData();
    };

    /**
     * 点击item
     * @param item
     */
    $scope.clickItem = function (item) {
      var type = 0;
      switch (item.mutiType) {
        case "1":
          type = 0;
          break;
        case "2":
          type = 1;
          break;
        case "3":
          type = 2;
          break;
      }
      if ($ionicPlatform.is("android")) {
        window.jsObj.myCollectionClickItem(item.collectSourceId, type, item.mutlName, item.mutiUrl);
      }
      if ($ionicPlatform.is("ios")) {
        myCollectionClickItem(item.collectSourceId, type, item.mutlName, item.mutiUrl);
      }
    }

  });
