angular.module('starter', ['ionic', 'starter.seeService', 'starter.apiService', 'starter.utilService', 'starter.config', 'starter.filter', 'starter.interceptor'])

  .run(function ($ionicPlatform, $rootScope, $ionicLoading,$http,Constants) {
    var deviceWidth = document.documentElement.clientWidth;
    var proportion = 20 / 750;
    if (deviceWidth > 750) deviceWidth = 750;
    if ($ionicPlatform.is("android")) {
      deviceWidth = deviceWidth * 375 / 360;
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    } else {
      document.documentElement.style.fontSize = deviceWidth * proportion + 'px';
    }
    $rootScope.$on("loading:show", function () {
      $ionicLoading.show({
        templateUrl: '../templates/loading.html'
      });
      //$ionicLoading.show({template: 'Loading...'});
    });
    $rootScope.$on("loading:hide", function () {
      $ionicLoading.hide();
    });

    $ionicPlatform.ready(function () {
      // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
      // for form inputs)
      if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
        cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
        cordova.plugins.Keyboard.disableScroll(true);

      }
      if (window.StatusBar) {
        // org.apache.cordova.statusbar required
        StatusBar.styleDefault();
      }
    });

    //网络请求全局配置
    $http.defaults.headers.get = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.post = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.put = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
    $http.defaults.headers.detele = {
      'user-appid': Constants.userAppId,
      'user-token': Constants.userToken
    };
  })

  .config(function ($ionicConfigProvider,$httpProvider) {

    $ionicConfigProvider.platform.ios.tabs.style('standard');
    $ionicConfigProvider.platform.ios.tabs.position('bottom');
    $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');

    $ionicConfigProvider.platform.ios.navBar.alignTitle('center');
    $ionicConfigProvider.platform.android.navBar.alignTitle('center');

    $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
    $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');

    $ionicConfigProvider.platform.ios.views.transition('ios');
    $ionicConfigProvider.platform.android.views.transition('android');

    $ionicConfigProvider.platform.ios.scrolling.jsScrolling(true);
    $ionicConfigProvider.platform.android.scrolling.jsScrolling(true);

    //添加http请求拦截器
    $httpProvider.interceptors.push('httpInterceptor');

  })
  .controller('SeeCtrl', function ($rootScope,$scope, $ionicHistory, seeService, $ionicPlatform,utilService,$ionicScrollDelegate) {
    $scope.showloading = true;
    $scope.showMoreloading = false;
    var showType = utilService.getQueryUrlString("showType");
    if (showType === undefined || showType == null || showType.length == 0) {
      if (seeService.getMutiType() == undefined) {
        seeService.setMutiType("01");
      }
    } else {
      switch (showType) {
        case "1":
          //眼界
          seeService.setMutiType("01");
          break;
        case "2":
          //课堂
          seeService.setMutiType("02");
          break;
        case "3":
          //榜样
          seeService.setMutiType("03");
          break;
        default:
          //默认显示
          seeService.setMutiType("01");
          break;
      }
    }
    setTypeStyle();
    seeService.setSearchText("");
    seeService.getTopMutiList();
    //数据改变广播
    $scope.$on('MutiDataList.MutiDataUpdated', function () {
      $scope.showloading = false;
      $scope.showMoreloading = false;
      $scope.mutiListData = seeService.getMutiListData();
      //取消刷新数据
      $scope.$broadcast('scroll.refreshComplete');
      //取消加载更多数据
      $scope.$broadcast('scroll.infiniteScrollComplete');
      $rootScope.$broadcast('loading:hide');
    });

    //下拉更新
    $scope.doRefresh = function () {
      $scope.showloading = false;
      //seeService.setSearchText("");
      //$("#searchInput").val("");
      seeService.getTopMutiList();
    }

    //上拉加载更多
    $scope.loadMore = function () {
      $scope.showMoreloading = true;
      seeService.getMoreMutiList();
    }

    //判断是否有数据
    $scope.hasData = function () {
      return $scope.showloading || seeService.hasData();
    };

    //判断是否有下页数据
    $scope.hasNextPage = function () {
      return seeService.hasNextPage();
    };

    /**
     * 点击item
     * @param item
     */
    $scope.clickItem = function (item) {
      var type = 0;
      switch (parseInt(item.mutiType)) {
        case 1:
          type = 0;
          break;
        case 2:
          type = 1;
          break;
        case 3:
          type = 2;
          break;
      }
      if ($ionicPlatform.is("android")) {
        window.jsObj.videoClickItem(item.mutiId, type, item.mutiName, item.mutiUrl);
      }
      if ($ionicPlatform.is("ios")) {
        videoClickItem(item.mutiId, item.mutiName, type, item.mutiUrl);
      }
    }

    /**
     * 改变tab
     * @param type tab类型
     */
    $scope.changeTab = function (type) {
      switch (type) {
        case 1:
          //眼界
          if ("01" != seeService.getMutiType()) {
            goTab("01");
          }
          break;
        case 2:
          //课堂
          if ("02" != seeService.getMutiType()) {
            goTab("02");
          }
          break;
        case 3:
          //榜样
          if ("03" != seeService.getMutiType()) {
            goTab("03");
          }
          break;
        default:
          break;
      }
    }

    /**
     * 切换tab
     * @param type
     */
    function goTab(type) {
      $rootScope.$broadcast('loading:show');
      seeService.setSearchText("");
      $("#searchInput").val("");
      seeService.setMutiType(type);
      $scope.showloading = true;
      $ionicScrollDelegate.$getByHandle('scrollHandle').resize();
      seeService.getTopMutiList();
      setTypeStyle();
    }

    /**
     * 键盘事件
     * @param event
     */
    $scope.showEvent = function (event) {
      if (event.keyCode == 13) {
        //搜索键
        $rootScope.$broadcast('loading:show');
        $("#searchInput").blur()
        var text = $("#searchInput").val();
        seeService.setSearchText(text);
        $scope.showloading = true;
        seeService.getTopMutiList();
      }
    };

    /**
     * 搜索内容改变事件
     */
    $scope.onChange = function () {
      var text = $("#searchInput").val();
      if(utilService.isNull(text)){
        $("#searchImg").css("display","");
      }else{
        $("#searchImg").css("display","none");
      }
    };

    /**
     * 设置选择样式
     */
    function setTypeStyle() {
      var type = seeService.getMutiType();
      $("#Look").removeClass("look");
      $("#School").removeClass("school");
      $("#Example").removeClass("example");
      $("#Look").removeClass("look-active");
      $("#School").removeClass("school-active");
      $("#Example").removeClass("example-active");
      switch (type) {
        case "01":
          $("#Look").addClass("look-active");
          $("#School").addClass("school");
          $("#Example").addClass("example");
          break;
        case "02":
          $("#Look").addClass("look");
          $("#School").addClass("school-active");
          $("#Example").addClass("example");
          break;
        case "03":
          $("#Look").addClass("look");
          $("#School").addClass("school");
          $("#Example").addClass("example-active");
          break;
      }
    }
  });
