/**
 * Created by 王海东 on 2016-07-22.
 * 自定义过滤器
 */
angular.module('starter.filter', [])
//时间过滤器
  .filter('dateFilter', function () {
    return function (input, param) {
      if (input === undefined || input == null || input.length < 8) {
        return input;
      } else {
        switch (param) {
          case "yyyy-MM-dd":
            var year = input.substring(0, 4);
            var month = input.substring(4, 6);
            var day = input.substring(6, 8);
            return year + "-" + month + "-" + day;
            break;
          case "yyyy-MM-dd hh:mm:ss":
            var year = input.substring(0, 4);
            var month = input.substring(4, 6);
            var day = input.substring(6, 8);
            var hour = input.substring(8, 10);
            var minute = input.substring(10, 12);
            var second = input.substring(12, 14);
            return year + "-" + month + "-" + day + " " + hour + ":" + minute + ":" + second;
            break;
          default:
            var year = input.substring(0, 4);
            var month = input.substring(4, 6);
            var day = input.substring(6, 8);
            return year + "-" + month + "-" + day;
            break;
        }
      }
    }
  })
  //时间过滤器 如几小时 几天前
  .filter("beforeDateFilter", function () {
    return function (input, param) {
      if (input === undefined || input == null || input.length < 14) {
        return "错误数据";
      } else {
        var oldDate = new Date();
        oldDate.setYear(parseInt(input.substring(0, 4)));
        oldDate.setDate(1);
        oldDate.setMonth(parseInt(input.substring(4, 6)) - 1);
        oldDate.setDate(parseInt(input.substring(6, 8)));
        oldDate.setHours(parseInt(input.substring(8, 10)))
        oldDate.setMinutes(parseInt(input.substring(10, 12)));
        oldDate.setSeconds(parseInt(input.substring(12, 14)));
        var result;
        var minute = 1000 * 60;
        var hour = minute * 60;
        var day = hour * 24;
        var halfamonth = day * 15;
        var month = day * 30;
        var now = new Date();
        if (param != undefined && param != null && param.length >= 14) {
          now.setYear(parseInt(param.substring(0, 4)));
          now.setDate(1);
          now.setMonth(parseInt(param.substring(4, 6)) - 1);
          now.setDate(parseInt(param.substring(6, 8)));
          now.setHours(parseInt(param.substring(8, 10)))
          now.setMinutes(parseInt(param.substring(10, 12)));
          now.setSeconds(parseInt(param.substring(12, 14)));
        }
        var diffValue = now.getTime() - oldDate.getTime();
        if (diffValue < 0) {
          return "错误数据";
        }
        var monthC = diffValue / month;
        var weekC = diffValue / (7 * day);
        var dayC = diffValue / day;
        var hourC = diffValue / hour;
        var minC = diffValue / minute;
        if (monthC >= 1) {
          //result = "" + parseInt(monthC) + "月前";
          result = input.substring(0, 4) + "-" + input.substring(4, 6) + "-" + input.substring(6, 8);
        }
        else if (weekC >= 1) {
          if (weekC == 1) {
            result = "" + parseInt(weekC) + "周前";
          } else {
            result = input.substring(0, 4) + "-" + input.substring(4, 6) + "-" + input.substring(6, 8);
          }
        }
        else if (dayC >= 1) {
          result = "" + parseInt(dayC) + "天前";
        }
        else if (hourC >= 1) {
          result = "" + parseInt(hourC) + "小时前";
        }
        else if (minC >= 1) {
          result = "" + parseInt(minC) + "分钟前";
        } else
          result = "刚刚";
        return result;
      }
    }
  })
  //问题过期时间过滤器
  .filter("overdueDateFilter", function () {
    return function (input, param) {
      if (input === undefined || input == null || input.length < 14) {
        return "错误数据";
      } else {
        var oldDate = new Date();
        var overdueHour = 48;//多少小时后过期
        if ($rootScope.sysInfo != undefined && $rootScope.sysInfo != null) {
          overdueHour = parseInt($rootScope.sysInfo.refundCountCyc);
        }
        oldDate.setFullYear(parseInt(input.substring(0, 4)));
        oldDate.setDate(1);
        oldDate.setMonth(parseInt(input.substring(4, 6)) - 1);
        oldDate.setDate(parseInt(input.substring(6, 8)));
        oldDate.setHours(parseInt(input.substring(8, 10)))
        oldDate.setMinutes(parseInt(input.substring(10, 12)));
        oldDate.setSeconds(parseInt(input.substring(12, 14)));
        oldDate = new Date(oldDate.getTime() - 1000 * 60 * 60 * overdueHour);
        var result;
        var minute = 1000 * 60;
        var hour = minute * 60;
        var day = hour * 24;
        var halfamonth = day * 15;
        var month = day * 30;
        var now = new Date();
        if (param != undefined && param != null && param.length >= 14) {
          now.setYear(parseInt(param.substring(0, 4)));
          now.setDate(1);
          now.setMonth(parseInt(param.substring(4, 6)) - 1);
          now.setDate(parseInt(param.substring(6, 8)));
          now.setHours(parseInt(param.substring(8, 10)))
          now.setMinutes(parseInt(param.substring(10, 12)));
          now.setSeconds(parseInt(param.substring(12, 14)));
        }
        var diffValue = now.getTime() - oldDate.getTime();
        if (diffValue < 0) {
          return "错误数据";
        }
        var monthC = diffValue / month;
        var weekC = diffValue / (7 * day);
        var dayC = diffValue / day;
        var hourC = diffValue / hour;
        var minC = diffValue / minute;
        if (overdueHour - parseInt(hourC) > 0) {
          result = (overdueHour - parseInt(hourC)) + "小时后过期";
        } else {
          result = "已过期";
        }
        /*if (monthC >= 1) {
         result = "已过期";
         }
         else if (weekC >= 1) {
         result = "已过期";
         }
         else if (dayC >= 1) {
         if (dayC >= 2) {
         result = "已过期";
         } else {
         result = (48 - parseInt(hourC)) + "小时后过期";
         }
         }
         else if (hourC >= 1) {
         result = "1天后过期";
         }
         else if (minC >= 1) {
         result = "2天后过期";
         } else
         result = "2天后过期";*/
        return result;
      }
    }
  })
  //网络地址过滤
  .filter("urlFilter", function (Constants, $rootScope) {
    return function (input) {
      if (input === undefined || input == null || input == "") {
        return "";
      } else {
        if (input.indexOf("http://") < 0 && input.indexOf("https://") < 0) {
          if ($rootScope.sysInfo != undefined && $rootScope.sysInfo != null) {
            return $rootScope.sysInfo.resourceServerUrl + input;
          } else {
            return Constants.resourceApi + input;
          }
        } else {
          return input;
        }
      }
    }
  })
  //数量过滤器
  .filter("numFilter", function () {
    return function (input) {
      if (input === undefined || input == null || input === "") {
        return "0";
      } else {
        return input;
      }
    }
  })
  //数量0过滤器
  .filter("numZeroFilter", function () {
    return function (input) {
      if (input === undefined || input == null || input === "" || input == 0 || input == "0") {
        return "";
      } else {
        return input;
      }
    }
  })
  //金钱过滤器
  .filter("moneyFilter", function () {
    return function (input) {
      if (input === undefined || input == null || input === "") {
        return "0";
      } else {
        return input;
      }
    }
  })
  //偷听费用过滤器
  .filter("listenMoneyFilter", function () {
    return function (input) {
      if (input === undefined || input == null || input === "") {
        return "0";
      } else {
        if (input.indexOf(".00") >= 0) {
          input = input.replace(".00", "");
        }
        return input;
      }
    }
  })
  //偷听后获取费用过滤器
  .filter("listenGetMoneyFilter", function ($rootScope, utilService) {
    return function (input) {
      if (input === undefined || input == null || input === "") {
        return "0";
      } else {
        if (utilService.isNull($rootScope.sysInfo)) {
          //没有获取到系统信息
          return (parseFloat(input) * 0.45).toFixed(2);
        } else {
          return (parseFloat(input) * parseFloat($rootScope.sysInfo.lThRatio) / 100).toFixed(2);
        }
      }
    }
  })
  //性别过滤器
  .filter("sexFilter", function () {
    return function (input) {
      if (input === undefined || input == null || input === "") {
        return "";
      } else {
        var sex = "";
        input = parseInt(input);
        switch (input) {
          case 0:
            sex = "男";
            break;
          case 1:
            sex = "女";
            break;
        }
        return sex;
      }
    }
  })
  //年龄过滤器
  .filter("ageFilter", function () {
    return function (input) {
      if (input === undefined || input == null || input === "") {
        return "";
      } else {
        var age;
        input = parseInt(input);
        switch (input) {
          case 0:
            age = "0-20岁";
            break;
          case 1:
            age = "20-30岁";
            break;
          case 2:
            age = "30-40岁";
            break;
          case 4:
            age = "40-50岁";
            break;
          case 5:
            age = "50-60岁";
            break;
          case 7:
            age = "60-70岁";
            break;
        }
        return age;
      }
    }
  })
  //空数据过滤器
  .filter('nullDataFilter', function () {
    return function (input, param) {
      if (input === undefined || input == null || input.length == 0) {
        return param;
      } else {
        return input;
      }
    }
  });

