/**
 * Created by 王海东 on 2017-02-16.
 * 自定义http拦截器
 */
angular.module('starter.interceptor', [])
  .factory('httpInterceptor', function ($q, Constants) {
    return {
      request: function (config) {
        var url = config.url;
        if (url.indexOf('http') >= 0 || url.indexOf('https') >= 0) {
          var guid = new Date().Format('yyyyMMddhhmmss') + getRandomCode();
          config.headers['user-account'] = Constants.userAccount;
          config.headers['user-certification'] = encryptAes(guid + url);
        }

        /**
         * 加密
         * @param data 原始数据
         * @returns {*} 加密数据
         */
        function encryptAes(data) {
          var key = CryptoJS.enc.Utf8.parse(Constants.userPas);
          var iv = CryptoJS.enc.Utf8.parse(Constants.aecIv);
          var srcs = CryptoJS.enc.Utf8.parse(data);
          var encrypted = CryptoJS.AES.encrypt(srcs, key, {iv: iv, mode: CryptoJS.mode.CBC, padding: CryptoJS.pad.Pkcs7});
          return CryptoJS.enc.Base64.stringify(encrypted.ciphertext);
        }

        /**
         * 获取随机数
         * @returns {number}
         */
        function getRandomCode() {
          var code = Math.floor(Math.random() * 10000000000);
          while (true) {
            if (code < 1000000000) {
              code = Math.floor(Math.random() * 10000000000);
            } else {
              break;
            }
          }
          return code;
        }

        return config || $q.when(config);
      },
    };
  });
