angular.module('starter.homeService', [])
  .service('homeService', function ($rootScope, Constants, apiService, utilService) {
    var hasNextPage = false;
    var pageIndex = 1;
    var qustionListData = [];//问题列表数据
    var adListData = [];//广告列表数据
    var mutiListData = [];//视频信息

    /**
     * 获取广告数据
     */
    this.getTopAdListData = function () {
      apiService.getAdsList().then(function (data) {
        //成功
        if (Constants.resultCode.SUCCESS == data.resultCode) {
          adListData = data.data;
          $rootScope.$broadcast('homepageadlist:success');
        }
      }, function (data) {
        //失败
      });
    }

    //获取首页数据
    this.getTopHomePageQuestionList = function () {
      pageIndex = 1;
      apiService.getHomePageQuestionList(utilService.getUserId(), pageIndex, Constants.firstDataTime).then(function (data) {
        //success
        if (Constants.resultCode.SUCCESS == data.resultCode) {
          qustionListData = data.data.questionLists;
          mutiListData = data.data.mutiinfoLists;
          hasNextPage = false;
          /*if (data.data.questionLists.length >= Constants.pageSize * pageIndex) {
            hasNextPage = true;
          } else {
            hasNextPage = false;
          }*/
        }
      }, function (data) {
        //error
      }).finally(function () {
        //发送广播
        $rootScope.$broadcast('homepagequestionlist:success');
      });
    }
    //获取下页数据
    this.getMoreHomePageQuestionList = function () {
      pageIndex++;
      var lastTime = qustionListData[qustionListData.length - 1].updTime;
      apiService.getHomePageQuestionList(utilService.getUserId(), pageIndex, lastTime).then(function (data) {
        //success
        if (Constants.resultCode.SUCCESS == data.resultCode) {
          qustionListData = data.data.questionLists;
          if (data.data.questionLists.length >= Constants.pageSize * pageIndex) {
            hasNextPage = true;
          } else {
            hasNextPage = false;
          }
        }
      }, function (data) {
        //error
      }).finally(function () {
        //发送广播
        $rootScope.$broadcast('homepagequestionlist:success');
      });
    }

    /**
     * 阅读广告
     * @param advertId 广告id
     */
    this.doReadAdvert = function (advertId) {
      apiService.doReadAdvert(advertId).then(function (data) {
        //success
        if (Constants.resultCode.SUCCESS == data.resultCode) {
        }
      }, function (data) {
        //error
      }).finally(function () {
        //发送广播
      });
    }

    /**
     * 获取广告列表数据
     * @returns {Array}
     */
    this.getAdListData = function () {
      return adListData;
    }

    //获取数据
    this.getQustionListData = function () {
      return qustionListData;
    }

    //获取视频数据
    this.getMutiListData = function () {
      return mutiListData;
    }

    //判断是否有下页数据
    this.hasNextPage = function () {
      if (qustionListData === undefined || !hasNextPage) {
        return false;
      } else {
        return true;
      }
    }
    //判断是否有数据
    this.hasData = function () {
      if (qustionListData === undefined || qustionListData.length == 0) {
        return false;
      } else {
        return true;
      }
    }
  });
