/**
 * Created by 王海东 on 2016-07-26
 * 我的收藏service
 */
angular.module('starter.myCollectionService', [])
    .service("myCollectionService", function ($rootScope, Constants, apiService, utilService) {
        var hasNextPage = false;
        var pageIndex = 1;
        var collectionListData = [];
        //获取首页数据
        this.getTopCollectionList = function () {
            pageIndex = 1;
            apiService.getMyCollect(utilService.getUserId(), pageIndex, Constants.firstDataTime).then(function (data) {
                //success
                if (Constants.resultCode.SUCCESS == data.resultCode) {
                    collectionListData = data.data;
                    if (data.data.length >= Constants.pageSize) {
                        hasNextPage = true;
                    } else {
                        hasNextPage = false;
                    }
                }
            }, function (data) {
                //error
            }).finally(function () {
                //发送广播
                $rootScope.$broadcast('collectionListData.Updated');
            });
        }
        //获取下页数据
        this.getMoreCollectionList = function () {
            pageIndex++;
            var lastTime = collectionListData[collectionListData.length - 1].updTime;
            apiService.getMyCollect(utilService.getUserId(), pageIndex, lastTime).then(function (data) {
                //success
                if (Constants.resultCode.SUCCESS == data.resultCode) {
                  var dataLength = data.data.length;
                  for (var i = 0; i < dataLength; i++) {
                    collectionListData.push(data.data[i]);
                  }
                  if (data.data.length >= Constants.pageSize) {
                    hasNextPage = true;
                  } else {
                    hasNextPage = false;
                  }
                }
            }, function (data) {
                //error
            }).finally(function () {
                //发送广播
                $rootScope.$broadcast('collectionListData.Updated');
            });
        }
        //获取数据
        this.getCollectionListData = function () {
            return collectionListData;
        }

        //判断是否有下页数据
        this.hasNextPage = function () {
            if (collectionListData === undefined || !hasNextPage) {
                return false;
            } else {
                return true;
            }
        }
        //判断是否有数据
        this.hasData = function () {
            if (collectionListData === undefined || collectionListData.length == 0) {
                return false;
            } else {
                return true;
            }
        }
    });
