/**
 * Created by 王海东 on 2016-07-26
 * 我的评论service
 */
angular.module('starter.myCommentsService', [])
    .service("myCommentsService", function ($rootScope, Constants, apiService, utilService) {
      var hasNextPage = false;
      var pageIndex = 1;
      /**问题评论数据*/
      var questionAppraiseListData = [];
      /**视频评论信息*/
      var mutiAppraiseListData = [];
      /**数据显示类型 0视频评论信息 1问题评论信息*/
      var showType = 0;

      /**
       * 初始化数据
       */
      this.init = function () {
        hasNextPage = false;
        pageIndex = 1;
        questionAppraiseListData = [];
        mutiAppraiseListData = [];
        showType = 0;
      }

      //获取视频评论首页数据
      this.getTopMutiAppraiseList = function () {
        pageIndex = 1;
        apiService.getMyAppraise(utilService.getUserId(), pageIndex, Constants.firstDataTime).then(function (data) {
          //success
          if (Constants.resultCode.SUCCESS == data.resultCode) {
            mutiAppraiseListData = data.data;
            if (data.data.length >= Constants.pageSize) {
              hasNextPage = true;
            } else {
              hasNextPage = false;
            }
          }
        }, function (data) {
          //error
        }).finally(function () {
          //发送广播
          $rootScope.$broadcast('appraiseListData.Updated');
        });
      }
      //获取视频评论下页数据
      this.getMoreMutiAppraiseList = function () {
        pageIndex++;
        var lastTime = mutiAppraiseListData[mutiAppraiseListData.length - 1].updTime;
        apiService.getMyAppraise(utilService.getUserId(), pageIndex, lastTime).then(function (data) {
          //success
          if (Constants.resultCode.SUCCESS == data.resultCode) {
            var dataLength = data.data.length;
            for (var i = 0; i < dataLength; i++) {
              mutiAppraiseListData.push(data.data[i]);
            }
            if (data.data.length >= Constants.pageSize) {
              hasNextPage = true;
            } else {
              hasNextPage = false;
            }
          }
        }, function (data) {
          //error
        }).finally(function () {
          //发送广播
          $rootScope.$broadcast('appraiseListData.Updated');
        });
      }

      //获取问题评论首页数据
      this.getTopQuestionAppraiseList = function () {
        pageIndex = 1;
        apiService.getMyQuestionAppraise(utilService.getUserId(), pageIndex, Constants.firstDataTime).then(function (data) {
          //success
          if (Constants.resultCode.SUCCESS == data.resultCode) {
            questionAppraiseListData = data.data;
            if (data.data.length >= Constants.pageSize) {
              hasNextPage = true;
            } else {
              hasNextPage = false;
            }
          }
        }, function (data) {
          //error
        }).finally(function () {
          //发送广播
          $rootScope.$broadcast('appraiseListData.Updated');
        });
      }
      //获取问题评论下页数据
      this.getMoreQuestionAppraiseList = function () {
        pageIndex++;
        var lastTime = questionAppraiseListData[questionAppraiseListData.length - 1].updTime;
        apiService.getMyQuestionAppraise(utilService.getUserId(), pageIndex, lastTime).then(function (data) {
          //success
          if (Constants.resultCode.SUCCESS == data.resultCode) {
            var dataLength = data.data.length;
            for (var i = 0; i < dataLength; i++) {
              questionAppraiseListData.push(data.data[i]);
            }
            if (data.data.length >= Constants.pageSize) {
              hasNextPage = true;
            } else {
              hasNextPage = false;
            }
          }
        }, function (data) {
          //error
        }).finally(function () {
          //发送广播
          $rootScope.$broadcast('appraiseListData.Updated');
        });
      }


      /**
       * 获取视频评论信息
       * @returns {*}
       */
      this.getMutiAppraiseListData = function () {
        return mutiAppraiseListData;
      }

      /**
       * 获取问题评论信息
       * @returns {*}
       */
      this.getQuestionAppraiseListData = function () {
        return questionAppraiseListData;
      }

      /**
       * 设置视频评论信息
       * @param data
       */
      this.setMutiAppraiseListData = function (data) {
        mutiAppraiseListData = data;
      }

      /**
       * 设置问题评论信息
       * @param data
       */
      this.setQuestionAppraiseListData = function (data) {
        questionAppraiseListData = data;
      }

      this.getShowType = function () {
        return showType;
      }

      /**
       * 设置显示类型
       * @param data
       */
      this.setShowType = function (data) {
        showType = data;
      }

      /**
       * 设置是否有下页数据
       * @param data true有 false没有
       */
      this.setHasNextPage = function (data) {
        hasNextPage = data;
      }

      /**
       * 判断是否有下页数据
       * @returns {boolean}
       */
      this.hasNextPage = function () {
        if (showType == 0) {
          //显示视频评论信息
          if (mutiAppraiseListData === undefined || !hasNextPage) {
            return false;
          } else {
            return true;
          }
        } else {
          //显示问题评论信息
          if (questionAppraiseListData === undefined || !hasNextPage) {
            return false;
          } else {
            return true;
          }
        }
      }
      //判断是否有数据
      this.hasData = function () {
        if (showType == 0) {
          //显示视频评论信息
          if (mutiAppraiseListData === undefined || mutiAppraiseListData.length == 0) {
            return false;
          } else {
            return true;
          }
        } else {
          //显示问题评论信息
          if (questionAppraiseListData === undefined || questionAppraiseListData.length == 0) {
            return false;
          } else {
            return true;
          }
        }
      }

      /**
       * 是否显示视频评论的数据
       */
      this.isShowMutiAppraise = function () {
        if (showType == 0) {
          return true;
        } else if (showType == 1) {
          return false;
        } else {
          return true;
        }
      }
    });
