angular.module('starter.seeService', [])
  .service('seeService', function ($rootScope, Constants, apiService, utilService) {
    var hasNextPage = false;
    var pageIndex = 1;
    var mutiListData = [];
    var mutiType = "01";//数据类型
    var searchText = "";//搜索内容
    //获取首页数据
    this.getTopMutiList = function () {
      pageIndex = 1;
      apiService.getMutiList(utilService.getUserId(), mutiType, "1", pageIndex, Constants.firstDataTime, searchText).then(function (data) {
        //success
        if (Constants.resultCode.SUCCESS == data.resultCode) {
          mutiListData = data.data;
          if (data.data.length >= Constants.pageSize) {
            hasNextPage = true;
          } else {
            hasNextPage = false;
          }
        }
      }, function (data) {
        //error
      }).finally(function () {
        //发送广播
        $rootScope.$broadcast('MutiDataList.MutiDataUpdated');
      });
    }
    //获取下页数据
    this.getMoreMutiList = function () {
      pageIndex++;
      var lastTime = mutiListData[0].updTime;
      apiService.getMutiList(utilService.getUserId(), mutiType, "1", pageIndex, lastTime, searchText).then(function (data) {
        //success
        if (Constants.resultCode.SUCCESS == data.resultCode) {
          var dataLength = data.data.length;
          for (var i = 0; i < dataLength; i++) {
            mutiListData.push(data.data[i]);
          }
          if (data.data.length >= Constants.pageSize) {
            hasNextPage = true;
          } else {
            hasNextPage = false;
          }
        }
      }, function (data) {
        //error
      }).finally(function () {
        //发送广播
        $rootScope.$broadcast('MutiDataList.MutiDataUpdated');
      });
    }
    //获取数据
    this.getMutiListData = function () {
      return mutiListData;
    }

    //判断是否有下页数据
    this.hasNextPage = function () {
      if (mutiListData === undefined || !hasNextPage) {
        return false;
      } else {
        return true;
      }
    }
    //判断是否有数据
    this.hasData = function () {
      if (mutiListData === undefined || mutiListData.length == 0) {
        return false;
      } else {
        return true;
      }
    }
    /**
     * 设置搜索内容
     * @param text
     */
    this.setSearchText = function (text) {
      searchText = text;
    }
    /**
     * 获取搜索内容
     * @returns {*}
     */
    this.getSearchText = function () {
      return searchText;
    }
    /**
     * 设置类型
     * @param mutiType
     */
    this.setMutiType = function (type) {
      mutiType = type;
    }
    /**
     * 获取类型
     * @returns {*}
     */
    this.getMutiType = function () {
      return mutiType;
    }
  });
